﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Private lst_Appointments As List
	Private lstCollission As List
	Private LeftPosition As Int = -1
	
	Type Appointment(Id As Int,StartDate As Long,EndDate As Long,Title As String)
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("frm_main")
	
	lst_Appointments.Initialize
	lstCollission.Initialize
	
	'Not working
	lst_Appointments.Add(CreateAppointment(1,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,13,30,0),"Test1"))
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,12,0,0),"Test4"))
	lst_Appointments.Add(CreateAppointment(3,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,12,0,0),"Test2"))
	lst_Appointments.Add(CreateAppointment(4,DateUtils.SetDateAndTime(2022,8,12,12,0,0),DateUtils.SetDateAndTime(2022,8,12,12,30,0),"Test3"))
	
	'Working
'	lst_Appointments.Add(CreateAppointment(1,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,13,30,0),"Test1"))
'	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,12,0,0),"Test4"))
	
	CreateAppointments
	
End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	CreateAppointments
End Sub

Private Sub CreateAppointments
	
	Root.RemoveAllViews
	
	Dim OneMinuteInMinute As Double = (Root.Height/48)/30
	
	lst_Appointments.SortType("StartDate",True)
	
	LeftPosition = -1
	
	For i = 0 To lst_Appointments.Size -1
		
		Dim Appointment As Appointment = lst_Appointments.Get(i)
		
		Dim Top As Double = OneMinuteInMinute*(DateTime.GetHour(Appointment.StartDate)*60) + OneMinuteInMinute*(DateTime.GetMinute(Appointment.StartDate))
		Dim Height As Double = (OneMinuteInMinute*(DateTime.GetHour(Appointment.EndDate)*60) + OneMinuteInMinute*(DateTime.GetMinute(Appointment.EndDate))) - Top
		
		Dim xlbl_Appointment As B4XView = CreateLabel("")
		xlbl_Appointment.Color = xui.Color_ARGB(255,Rnd(0,256),Rnd(0,256),Rnd(0,256))
		xlbl_Appointment.Text = Appointment.Title
		xlbl_Appointment.SetTextAlignment("TOP","LEFT")
		xlbl_Appointment.TextColor = xui.Color_White
		
		Root.AddView(xlbl_Appointment,0,Top,Root.Width,Height)
		
		'CheckOverlapping(i,xlbl_Appointment,Appointment)
		CheckOverlapping2(xlbl_Appointment,Appointment)
		
	Next
	
End Sub

Private Sub CheckKolission(Appointment1 As Appointment,Appointment2 As Appointment) As Boolean
	Return ((Appointment1.StartDate >= Appointment2.EndDate) Or (Appointment1.EndDate <= Appointment2.StartDate)) = False And DateUtils.IsSameDay(Appointment2.StartDate,Appointment2.EndDate) = True
End Sub

Private Sub CheckOverlapping(i As Int,xlbl_Appointment As B4XView,Appointment1 As Appointment)
	
	Dim Appointment2 As Appointment = IIf(i > 0,lst_Appointments.Get(i -1),lst_Appointments.Get(i)) 'Get the Appointment that is before Appointment1
	
	Dim Go As Boolean = False 'If Go = True then no more collissions detected
						
	If CheckKolission(Appointment1,Appointment2) Then
				
		lstCollission.Add(i) 'If the previous appointment conflicts with our appointment, add the index to the list.
	
		If i > 0 Then
			'Checks if the item is already in the list
			Dim Found As Boolean = False
			For Each test As Int In lstCollission
				If test = (i -1) Then Found = True
			Next
			If Found = False Then lstCollission.Add(i-1)
		End If
	
	Else
		Go = True 'no more collissions detected
	End If
					
	If i = (lst_Appointments.Size -1) Then Go = True 'or the appointment is the last item in the list
					
	If Go = True Then
						
						
		lstCollission.Sort(True)
		'Adjusts the appointments in width and left
		For app2 = 0 To lstCollission.Size -1
			Dim xlbl_Item As B4XView = Root.GetView(lstCollission.Get(app2))
						
			Dim ListSize As Int = lstCollission.Size
						
			xlbl_Item.Left = (Root.Width/ListSize)*app2
			xlbl_Item.Width = Root.Width/ListSize
						
		Next
		lstCollission.Clear
	End If
	
End Sub

Private Sub CheckOverlapping2(xlbl_Appointment As B4XView,Appointment1 As Appointment)

	Dim Divider As Int = 1
	For test = 0 To lst_Appointments.Size -1
				
		Dim Appointment2 As Appointment = lst_Appointments.Get(test)
				
		If Appointment1.id <> Appointment2.Id And CheckKolission(Appointment1,Appointment2) Then

			Dim Appointment3 As Appointment = IIf((test -1) >= 0,lst_Appointments.Get(test -1),lst_Appointments.Get(test +1))
						
			If  CheckKolission(Appointment3,Appointment2) = True Then
				Divider = Divider +1
					
				If  CheckKolission(Appointment3,Appointment1) = False Then
					LeftPosition = 0
				End If

			End If
								
		End If
				
	Next
			
	LeftPosition = LeftPosition +1
	If Divider = 0 Or Divider = 1 Then LeftPosition = 0
						
	xlbl_Appointment.Width = ((Root.Width)/Divider)
	xlbl_Appointment.Left = xlbl_Appointment.Width * LeftPosition
					
End Sub

Private Sub CreateLabel(EventName As String) As B4XView
	Dim lbl As Label
	lbl.Initialize(EventName)
	Return lbl
End Sub

Public Sub CreateAppointment (Id As Int, StartDate As Long, EndDate As Long, Title As String) As Appointment
	Dim t1 As Appointment
	t1.Initialize
	t1.Id = Id
	t1.StartDate = StartDate
	t1.EndDate = EndDate
	t1.Title = Title
	Return t1
End Sub